package SudokuNvariabel;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;




@SuppressWarnings("serial")
class MyPanel extends JPanel implements ChangeListener,ItemListener,ActionListener
{
	int breite= 900;
    int hoehe  = breite;
    abWrapper ab;
    boolWrapper bw;
    Sudoku feld;
    int sdim;

    Box controls;
    JPanel graphPanel;
    JSlider aSlider, bSlider;
    JLabel  aLabel,  bLabel;
    JCheckBox BeschriftungsButton, FarbButton;
    JButton genBut;
    JTextField tf;
    
	public MyPanel(int sdim) 
    {

		this.sdim=sdim;
		
		ab=new abWrapper(10,10);
		bw=new boolWrapper(true,true);

		aSlider= getSlider(200, 800, 600, 100, 105);
		if(sdim<4)
			bSlider= getSlider(0, sdim*sdim, 0, 1, 1);
		else
			bSlider= getSlider(0, sdim*sdim, 0, 5, 5);
        aLabel = new JLabel("Breite");
        bLabel = new JLabel("Highlighting");
        
        genBut=new JButton("ReGenerate");
        tf=new JTextField();
        tf.setEditable(false);

        controls = new Box(BoxLayout.Y_AXIS);

        controls.add(aLabel);
        controls.add(aSlider);
        
        controls.add(bLabel);
        controls.add(bSlider);
        
        BeschriftungsButton =getCheckBox("Lschmodus");
        controls.add(BeschriftungsButton);
        

        FarbButton =getCheckBox("Farbmodus");
        controls.add(FarbButton);
        
        controls.add(genBut);
        controls.add(tf);

		feld=new Sudoku(sdim);
		feld.generate();

        
        graphPanel = new GPanel(breite,	hoehe,ab, bw, feld) ;
  
        graphPanel.setBackground(Color.white);

        add(graphPanel);
        add(controls);

        aSlider.addChangeListener(this);			// YY
        bSlider.addChangeListener(this);
        
        BeschriftungsButton.addItemListener(this);  // XX
        FarbButton.addItemListener(this);
        
        genBut.addActionListener(this);
        
        tf.addActionListener(this);
        
        this.stateChanged(null);

    }//Konstruktor MyPanel

    public JSlider getSlider(int min, int max, int init, int mjrTkSp, int mnrTkSp) 
    {
        JSlider slider = new JSlider(JSlider.HORIZONTAL, min, max, init);
        slider.setPaintTicks(true);
        slider.setMajorTickSpacing(mjrTkSp);
        slider.setMinorTickSpacing(mnrTkSp);
        slider.setPaintLabels(true);
        // slider.addChangeListener(new SliderListener());  // stattdessen: YY
        return slider;
      }
	
    public JCheckBox getCheckBox(String label)
    {
    	JCheckBox jb=new JCheckBox(label);
    	jb.setMnemonic(KeyEvent.VK_C);
        jb.setSelected(true);
        //jb.addItemListener(this); // stattdessen: XX
    	return jb;
    }
    
        @Override
        public void stateChanged(ChangeEvent event) 
        {
        	ab.a  =aSlider.getValue();
            ab.b  =bSlider.getValue();
            aLabel.setText("Breite: " + ab.a);
            bLabel.setText("Highlighting: " + ab.b);
            graphPanel.repaint();
        }

		@Override
		public void itemStateChanged(ItemEvent e) 
		{
			Object source = e.getItemSelectable();
	        if (source == BeschriftungsButton) 
	        	if (e.getStateChange() == ItemEvent.SELECTED) 
	        		bw.beschr=true;
	        	else 
	        		bw.beschr=false;
	        if (source == FarbButton) 
	        	if (e.getStateChange() == ItemEvent.SELECTED) 
	        		bw.farbe=true;
	        	else 
	        		bw.farbe=false;
			graphPanel.repaint();
		}

		@Override
		public void actionPerformed(ActionEvent e) 
		{
			Object source = e.getSource();
			if(source==genBut)
			{
				if(e.getActionCommand() != null)
				{
					feld.generate();
					Boolean b=new Boolean(feld.check());
					tf.setText(/*feld.f[1][0]+" "+*/b.toString()+"");
					graphPanel.repaint();
				}
			}
		}

}//class MyPanel